# Instance

## ApplicationPrototype. Instance

#### new Instance()

Source:
  - dictionary.d.js, line 5

### Methods

#### (static) bind(event, callbackopt, listenersConfigopt) → {string}

Source:
  - dictionary.d.js, line 40

returns listener Id

##### Parameters:

Name | Type | Attributes | Description
--- | --- | --- | ---
`event` | string | function |  | event name of function with name
`callback` | function | ApplicationPrototype.Instance.BindListenerConfig | <optional> | function that will listen data
`listenersConfig` | ApplicationPrototype.Instance.BindListenerConfig | string | <optional> | of lis event name of function with name

##### Returns:

Type
  string

#### (static) crudEvents(context, publicMethods, privateMethods) → {ApplicationPrototype.Instance}

Source:
  - dictionary.d.js, line 59

returns listener Id

##### Parameters:

Name | Type | Description
--- | --- | ---
`context` | Object.<any> | will be used as a base for ApplicationPrototype instance that will be returned
`publicMethods` | Object.<function()> | list of public methods available from returned instance
`privateMethods` | Object.<function()> | list of private methods available only for instance's methods

##### Returns:

Type
  ApplicationPrototype.Instance

#### (static) off(event, specifiedEventIdopt) → {boolean}

Source:
  - dictionary.d.js, line 50

remove all event listeners

##### Parameters:

Name | Type | Attributes | Description
--- | --- | --- | ---
`event` | string |  | event or events names separated by comma
`specifiedEventId` | string | <optional> | event name of function with name

##### Returns:

Type
  boolean

#### (static) on(event, callbackopt, specifiedEventId) → {string}

Source:
  - dictionary.d.js, line 20

returns listener Id

##### Parameters:

Name | Type | Attributes | Description
--- | --- | --- | ---
`event` | string | function |  | event name of function with name
`callback` | function | <optional> | function that will listen data
`specifiedEventId` | string |  | event name of function with name

##### Returns:

Type
  string

#### (static) once(event, callbackopt, specifiedEventId) → {string}

Source:
  - dictionary.d.js, line 30

returns listener Id

##### Parameters:

Name | Type | Attributes | Description
--- | --- | --- | ---
`event` | string | function |  | event name of function with name
`callback` | function | <optional> | function that will listen data
`specifiedEventId` | string |  | event name of function with name

##### Returns:

Type
  string

#### (static) property(getter, setteropt, configopt)

Source:
  - dictionary.d.js, line 78

##### Parameters:

Name | Type | Attributes | Description
--- | --- | --- | ---
`getter` | ApplicationPrototype.PropertyHandler |  | function with name
`setter` | ApplicationPrototype.PropertyHandler | <optional> |
`config` | object | <optional> | ###### Properties
Name | Type | Attributes | Default | Description
--- | --- | --- | --- | ---
`configurable` | boolean | <optional> | `true` |
`enumerable` | boolean | <optional> | `true` |

#### (static) property(propertyName, getter, setteropt, configopt)

Source:
  - dictionary.d.js, line 78

##### Parameters:

Name | Type | Attributes | Description
--- | --- | --- | ---
`propertyName` | string |  |
`getter` | ApplicationPrototype.Instance.PropertyHandler |  |
`setter` | ApplicationPrototype.Instance.PropertyHandler | <optional> |
`config` | object | <optional> | ###### Properties
Name | Type | Attributes | Default | Description
--- | --- | --- | --- | ---
`configurable` | boolean | <optional> | `true` |
`enumerable` | boolean | <optional> | `true` |

##### Fires:

- ApplicationPrototype.Instance.event:__onSet
- ApplicationPrototype.Instance.event:__onGet
- ApplicationPrototype.Instance.event:__afterGet
- ApplicationPrototype.Instance.event:__afterGet
- ApplicationPrototype.Instance.event:__onSet::propName
- ApplicationPrototype.Instance.event:__onGet::propName
- ApplicationPrototype.Instance.event:__afterGet::propName
- ApplicationPrototype.Instance.event:__afterGet::propName

### Type Definitions

#### BindListenerConfig

Source:
  - dictionary.d.js, line 11

##### Properties:

Name | Type | Attributes | Default | Description
--- | --- | --- | --- | ---
`listenedBefore` | boolean | <optional> | `true` | allow listeners before method call
`listenedOn` | boolean | <optional> | `true` | allow listeners on method call ( is after )
`listenedAfter` | boolean | <optional> | `true` | allow listeners after method call ( is after small delay )
`allowInterruption` | boolean | <optional> | `true` |

configuration for bind listeners

##### Type:

- object

#### PropertyHandler(value, lastValue, isSetter)

Source:
  - dictionary.d.js, line 69

returns listener Id

##### Parameters:

Name | Type | Description
--- | --- | ---
`value` | any | is undefined when `isSetter = true`
`lastValue` | any |
`isSetter` | boolean |

### Events

#### __afterGet

Source:
  - dictionary.d.js, line 121

##### Properties:

Name | Type | Description
--- | --- | ---
`propName` | string |
`value` | any |
`lastValue` | any |

##### Type:

- object

#### __afterGet::propName

Source:
  - dictionary.d.js, line 152

##### Properties:

Name | Type | Description
--- | --- | ---
`value` | any |
`lastValue` | any |

##### Type:

- object

#### __afterSet

Source:
  - dictionary.d.js, line 129

##### Properties:

Name | Type | Description
--- | --- | ---
`propName` | string |
`value` | any |
`lastValue` | any |

##### Type:

- object

#### __afterSet::propName

Source:
  - dictionary.d.js, line 159

##### Properties:

Name | Type | Description
--- | --- | ---
`value` | any |
`lastValue` | any |

##### Type:

- object

#### __onGet

Source:
  - dictionary.d.js, line 105

##### Properties:

Name | Type | Description
--- | --- | ---
`propName` | string |
`value` | any |
`lastValue` | any |

##### Type:

- object

#### __onGet::propName

Source:
  - dictionary.d.js, line 138

##### Properties:

Name | Type | Description
--- | --- | ---
`value` | any |
`lastValue` | any |

##### Type:

- object

#### __onSet

Source:
  - dictionary.d.js, line 113

##### Properties:

Name | Type | Description
--- | --- | ---
`propName` | string |
`value` | any |
`lastValue` | any |

##### Type:

- object

#### __onSet::propName

Source:
  - dictionary.d.js, line 145

##### Properties:

Name | Type | Description
--- | --- | ---
`value` | any |
`lastValue` | any |

##### Type:

- object